# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Action d'éxécution de commande
#
#
###########################################################################
"""
    Execution d'une commande système
"""
from twisted.python import log
from ead2.backend.actions.lib.widgets import ajax
from ead2.backend.actions.lib.main import Main
from ead2.backend.config.config import module
try:
    from ead2.backend.config.cmd import CMDS
except:
    CMDS = {}

class Console(Main):
    """
        action de mise en forme de bouton d'éxécution de commande
    """
    name = "cmd_console"
    libelle = "Console"
    description = "Lancez des commandes sur le système"
    title = "Console de lancement de script"
    category = "Système"
    template = "console_system"
    widget_templates = ['main']
    btn_container_tmpl = "consolebtn%s"

    def execute(self):
        self.parse_request()
        return self.send(self._get_page())

    def send(self, dico):
        return self.send_all(dico, template=self.template, templates=self.widget_templates)

    def _get_page(self):
        """
            renvoie la description de la page d'éxécution de commande (un bouton)
        """
        title = self.title
        if CMDS.get(module, []):
            toexec = ""
            containers = []
            for indice, cmd_actionname in enumerate(CMDS.get(module,[])):
                container = self.btn_container_tmpl % indice
                containers.append(container)
                toexec += ajax.call(self.server_nb,
                                    cmd_actionname,
                                    container=container,
                                    only=False)
            return dict(toexec=toexec,
                        containers=containers,
                        title=self.title
                        )
        else:
            defaultmessage = "Aucune commande n'est disponible"
            return dict(defaultmessage=defaultmessage, title=self.title)

