# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
###########################################################################
"""
    Importation sconet
"""
from ead2.backend.lib.action import Dict

from ead2.backend.actions.lib.importation.fichier import BaseImportationFichier
from scribe.importation.config import (CSV_FILES,
                                       CSV_FILEVARNAMES)

class ImportationCsv(BaseImportationFichier):
    """
        Importation de type CSV
        Téléchargement / Parsing / Importation
    """
    data_type = 'csv'
    name = 'scribe_extraction_csv'
    description = 'Importation de fichier CSV'
    libelle = description
    all_file_descriptions = CSV_FILES
    request_keys = ['server',
                    'action',
                    'category_type',
                    'import_type',
                    'data_type',
                    'nomdefichier',
                    'filename',
                    'finished',
                    'parse',
                    'refresh_parse',
                    'importation',
                    'refresh_importation',
                    ]

    # variable de reception du contenu de fichier (original)
    origfilevarnames  = CSV_FILEVARNAMES

    # pool pour les noms de variables de réception
    filevarnames = []
    request_keys.extend(CSV_FILEVARNAMES['eleve_ss_resp'])
    request_keys.extend(CSV_FILEVARNAMES['enseignant'])
    request = Dict(default={}, keys=request_keys)
    file_download_entete = "Importation de '%s' au format : CSV"
